# $Hg$

import kwexpander

def updatekw(ui, repo, hooktype, **args):
    '''Important: returns False on success, True on failure.'''

    if hooktype != 'update':
        # bail out with error
        return True

    p1, p2 = args['parent1'], args['parent2']
    node1 = repo.changelog.lookup(p1)
    if p2:
        node2 = repo.changelog.lookup(p2)
        # next line for debugging only (check merges)
        ui.warn('parent2: %s\n' % p2)
    else:
        node2 = None

    (modified, added, removed, deleted,
            unknown, ignored, clean) = repo.status(node1=node1, node2=node2)
    candidates = modified + added + clean

    return kwexpander.expandkw(ui, repo,
            node1, p1, candidates, update=True)
